CC			= gcc
LEX			= flex
YACC		= bison
LINK		= gcc
INSTALL		= ginstall
INCLUDES	= -I../include -I./include
DEFINES		=
CFLAGS		= -g -c -O3 -Wall $(INCLUDES) $(DEFINES) $(EXTRA_CFLAGS)
LDFLAGS		= -L../library -Wall $(EXTRA_LDFLAGS)
LIBS		= ../library/libwebsuite.a

all: $(PROGNAME) $(EXTRATGTS)

objects: $(OBJECTS)

sources: $(SOURCES)

$(PROGNAME): $(OBJECTS) $(SOURCES) $(LIBS)
	$(LINK) $(LDFLAGS) -o $(PROGNAME) $(OBJECTS) $(LIBS) $(ELIBS)

%.o: %.c
	$(CC) $(CFLAGS) -o $*.o $*.c

%.c: %.yy
	$(LEX) -o$*.c $*.yy

%.c : %.y
	$(YACC) -vd -o$*.c $*.y

dep : $(SOURCES)
	$(CC) -MM $(CFLAGS) *.c > .depend

# We don't install EXTRATGTS
install : all
	if [ -n "$(TARGET)" ] ; then \
		$(INSTALL) -s -m 755 $(PROGNAME) $(TARGET) ; \
	fi

clean: dummy
	rm -f core $(PROGNAME) $(OBJECTS) $(SOURCES) $(EXTRATGTS)

dummy:
