#include <stdio.h>
#include <string.h>
#include "websuite.h"

#define MAXBUF 10

void
vector_print(vector_t *v)
{
	int		 len;
	int		 i;
	int		 x;

	len = vector_length(v);
	for (i = 0; i < len; i++) {
		x = (int)vector_data(v, i);
		printf(" %3.3d", x);
	}
}

void
analyse(char *data)
{
	char		 buf[MAXBUF];
	char		*cp;
	int			 i = 3;
	char		*dp;
	char		*np;
	int			 count;

	int			 diff;
	hash_t		*dh;
	vector_t	*v;

	dh = hash_new((delete_t)vector_delete, 0);

	for (cp = data; *(cp + i - 1); cp++) {
		strncpy(buf, cp, i);
		buf[i] = 0;
		if (hash_get(dh, buf)) continue;

		dp = data;
		count = 0;
		diff = 0;
		v = vector_new(NULL, 0);
		while ((np = strstr(dp, buf))) {
			count++;
			if (count > 1) {
				diff = np - dp;
				vector_push_back(v, (void *)diff);
			}
			dp = np + 1;
		}
		hash_add(dh, buf, v);
		printf("%d\t%s ", count, buf);
		vector_print(v);
		printf("\n");
	}

	hash_delete(dh);
}

int
main(int argc, char **argv)
{
	FILE	*input;
	char	 line[BUFSIZ];
	rope_t	*r;

	if (argc != 2) {
		printf("Usage: %s <file>\n", argv[0]);
		return 1;
	}

	input = fopen(argv[1], "r");
	if (!input) {
		perror(argv[1]);
		return 2;
	}

	r = rope_new("");

	while (fgets(line, BUFSIZ, input)) {
		line[strcspn(line, "\r\n")] = 0;
		rope_add(r, line);
	}

	analyse(rope_chars(r));

	fclose(input);

	return 0;
}
