#!/usr/bin/perl

# This is an unmaintainable Perl script.
#
# Any maintenance of this script is at the sole risk of the maintainer
# and no liability, expressed or implied is accepted by the author.
# Do not use this script in aeroplanes or nuclear installations.
#
# S.

use strict;

my(%opts) = (
	"sendmail"		=> "/usr/lib/sendmail",
	"webmaster"		=> "webmaster\@localhost",
	"datadir"		=> "/opt/www/sites",
	"cgidir"		=> "/var/lib/httpd/cgi-bin",
	"resourcedir"	=> "/webletresources",
	"documentroot"	=> "/var/lib/httpd/htdocs",
	"vcard_user"	=> "vcard",
	"vcard_host"	=> "",
	"linkflags"		=> "",
	"log_host"		=> "127.0.0.1",
	"log_port"		=> "10000"
	);
my $configfile = "Configuration";
my $config_h = "include/config.h";
my $defs_make = "Defs.make";
my @errors = ();

open(CFG, $configfile) or die "Can't open $configfile : $!";

while (<CFG>) {
	my($key,$value);
	next if /^\s*(#|$)/;
	chomp;
	s/#.*//;
	($key, $value) = split(/=/, $_, 2);
	$key =~ s/^\s*(.*?)\s*$/$1/;
	$value =~ s/^\s*(.*?)\s*$/$1/;
	push(@errors, "Invalid command '$key' on line line $."), next
		if not defined($opts{$key});
	$opts{$key} = $value;
}

close(CFG) or die "Can't close $configfile : $!";

die "One or more fatal errors in config file:\n" . join("\n", @errors)
	if $#errors >= 0;

print "Configuration loaded from $configfile.\n";
foreach (sort keys %opts) {
	print "$_\t=> $opts{$_}\n";
}
# print "Press <enter> to continue, ^C to abort.\n";
# my $temp = <STDIN>;

print "Creating:";

open(CONFIG, ">$config_h") or die "Can't open $config_h : $!";

print CONFIG << "EOM";
#ifndef __CONFIG_H__
#define __CONFIG_H__
/* Do not modify this file. Any changes will be overwritten by
 * configure.pl. Please modify the file Configuration instead and
 * re-run configure.pl.
 */
#define DIR_DATA        "$opts{'datadir'}"
#define DIR_RESOURCE    "$opts{'resourcedir'}"
#define BIN_SENDMAIL    "$opts{'sendmail'}"
#define ADM_EMAIL       "$opts{'webmaster'}"
#define VCARD_SRC_USER	"$opts{'vcard_user'}"
#define VCARD_SRC_HOST	"$opts{'vcard_host'}"
#define LOG_HOST		"$opts{'log_host'}"
#define LOG_PORT		$opts{'log_port'}
#endif
EOM

close CONFIG or die "Can't close $config_h : $!";
print " $config_h";

open(DEFS, ">$defs_make") or die "Can't open $defs_make : $!";

print DEFS << "EOM";
# Defs.make
# This file is included by Makefile in all subdirectories.
# Do not modify this file, any changes will be overwritten by
# configure.pl
CGIDIR	= $opts{'cgidir'}
HTMLDIR	= $opts{'documentroot'}
DATADIR	= $opts{'datadir'}
ELIBS	= $opts{'linkflags'}
EOM

close DEFS or die "Can't close $defs_make : $!";
print " $defs_make";

print " done.\n";
