/*
 * Web site error daemon - main routine
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include "library.h"
#include "log.h"
#include "vector.h"
#include "runtime.h"
#include "recv.h"

int
main_loop(vector_t *runtime)
{
	fd_set	 readset;
	int		 fd;

	fd = recv_bind(LOG_PORT);

	while (1) {
		FD_ZERO(&readset);
		FD_SET(fd, &readset);
		select((fd + 1), &readset, NULL, NULL, NULL);
		recv_recv(runtime, fd);
	}
}

int
main(void)
{
	vector_t	*runtime;
	library_init("daemon");
	runtime = runtime_new("weberror.conf");
	main_loop(runtime);

	return 0;
}
