/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -apCtg -H dsyslog_hash -N dsyslog_pripair pri.gperf  */
struct _pripair { char *name; int priority; };

#define TOTAL_KEYWORDS 13
#define MIN_WORD_LENGTH 1
#define MAX_WORD_LENGTH 7
#define MIN_HASH_VALUE 1
#define MAX_HASH_VALUE 20
/* maximum key range = 20, duplicates = 0 */

#ifdef __GNUC__
inline
#endif
static unsigned int
dsyslog_hash (register const char *str, register int len)
{
  static const unsigned char asso_values[] =
    {
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21,  0, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
     21, 21, 21, 21, 21, 21, 21, 14, 21, 10,
      5,  0, 21,  0, 21,  5, 21, 21, 21, 21,
      0,  0,  0, 21, 15, 21,  0, 21, 21,  4,
     21, 21, 21, 21, 21, 21, 21, 21,
    };
  return len + asso_values[str[len - 1]] + asso_values[str[0]];
}

#ifdef __GNUC__
inline
#endif
const struct _pripair *
dsyslog_pripair (register const char *str, register int len)
{
  static const struct _pripair wordlist[] =
    {
      {"",}, 
      {"*", 		PRI_ALL},
      {"",}, {"",}, 
      {"none", 	PRI_NONE},
      {"emerg", 	PRI_EMERG},
      {"notice", 	PRI_NOTICE},
      {"",}, 
      {"warn", 	PRI_WARNING},
      {"info", 	PRI_INFO},
      {"debug", 	PRI_DEBUG},
      {"warning", PRI_WARNING},
      {"",}, {"",}, 
      {"crit", 	PRI_CRIT},
      {"panic", 	PRI_EMERG},
      {"",}, {"",}, 
      {"err", 	PRI_ERR},
      {"alert", 	PRI_ALERT},
      {"error", 	PRI_ERR},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = dsyslog_hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        {
          register const char *s = wordlist[key].name;

          if (*s == *str && !strcmp (str + 1, s + 1))
            return &wordlist[key];
        }
    }
  return 0;
}
