#include <stdlib.h>
#include <string.h>
#include "library.h"
#include "cgi.h"
#include "utils.h"
#include "hash.h"
#include "vector.h"
#include "rope.h"
#include "log.h"

vector_t	*datafile_read(hash_t *cgihash, rope_t *pathstr);
void		*template_new(void *pathstr);
void		 template_parse(rope_t *tpt, vector_t *results);

int
main(void)
{
	hash_t		*cgihash;
	vector_t	*results;
	rope_t		*tptstr;
	rope_t		*datastr;
	char		*temp;

	library_init("datafile");

	cgihash = cgi_hash_new();

	temp = hash_get(cgihash, "Company");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'Company' parameter in "
						"cgi hash table");
		exit(0);
	}

	tptstr = rope_new("/opt/www/scripts/datafile/company/");
	rope_add(tptstr, temp);

	datastr = rope_new(rope_chars(tptstr));

	rope_add(tptstr, "/templates/");

/* Template file */
	temp = hash_get(cgihash, "TemplateTitle");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'TemplateTitle' parameter in "
						"cgi hash table");
		exit(0);
	}
	temp[strcspn(temp, "/")] = 0;
	rope_add(tptstr, temp);
	rope_add(tptstr, ".tpt");

/* Data file */
	rope_add(datastr, "/DataFiles/");
	temp = hash_get(cgihash, "DataFileTitle");
	if (!temp) {
		log("cgiconf", PRI_CRIT, "No 'DataFileTitle' parameter in "
						"cgi hash table");
		exit(0);
	}
	temp[strcspn(temp, "/")] = 0;
	rope_add(datastr, temp);
	rope_add(datastr, ".db");

/* Results */
	results = datafile_read(cgihash, datastr);

	template_parse(tptstr, results);

	return 0;
}
