#ifndef __LIST_H__
#define __LIST_H__

#include "library.h"

typedef void *list_data_t;
typedef delete_t list_delete_t;

typedef
struct _list_item_t {
	struct _list_item_t	*next;
	struct _list_item_t	*prev;
	char				*label;
	list_data_t			 data;
} list_item_t;

typedef
struct _list_t {
	list_item_t		*root;
	int				 length;
	list_delete_t	 i_delete;
} list_t;

typedef
struct _list_iterator_t {
	list_t		*list;
	list_item_t	*node;
} list_iterator_t;

list_t	*list_new(list_delete_t func);
void	 list_delete(list_t *list);
int		 list_length(list_t *list);

void	 list_data_insert(list_iterator_t *iterator,
						char *label, list_data_t data);
void	 list_data_remove(list_iterator_t *iterator);

list_data_t  list_data_read_data(list_iterator_t *iterator);
char	*list_data_read_label(list_iterator_t *iterator);

list_iterator_t *list_iterator_new(list_t *list);
void	 list_iterator_delete(list_iterator_t *iterator);
bool	 list_iterator_begin(list_iterator_t *iterator);
bool	 list_iterator_end(list_iterator_t *iterator);
bool	 list_iterator_prev(list_iterator_t *iterator);
bool	 list_iterator_next(list_iterator_t *iterator);

#endif
