%{
/*
 * Web error document for Apache - template parser
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "library.h"
#include "log.h"

char	*message;
char	*codestr;
char	*httpstr;

%}

%option nounput
%option noyywrap
%option caseless

%%

\{Message\}		{ printf("%s", message);	}
\{Code\}		{ printf("%s", codestr);	}
\{HTTPMessage\}	{ printf("%s", httpstr);	}
\r\n			{ ECHO;						}
\r				{ printf("\r\n");			}
\n				{ printf("\r\n");			}

%%

void
template_parse(char *path, char *str, char *cstr, char *hstr)
{
	FILE	*input;

	message = str;
	codestr = cstr;
	httpstr = hstr;

	input = fopen(path, "r");
	if (!input) {
		log("cgisys", PRI_ERR, "TPT: Could not open file \"%s\": %s",
						path, strerror(errno));
		printf("Content-type: text/plain\r\n\r\n");
		printf("An error was caused\r\n");
		printf("The error message was \"%s\"\r\n", str);
		return;
	}

	printf("Content-type: text/html\r\n\r\n");
	yyin = input;
	yylex();
}
